"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/loaders/ignext-server-loader.ts
var ignext_server_loader_exports = {};
__export(ignext_server_loader_exports, {
  default: () => ignextServerLoader
});
module.exports = __toCommonJS(ignext_server_loader_exports);
var import_buffer = require("buffer");
var import_path = __toESM(require("path"));
var import_querystring = require("querystring");
var import_stringify_request = require("next/dist/build/webpack/stringify-request");
function toArray(value) {
  if (!value) {
    return [];
  }
  if (Array.isArray(value)) {
    return value;
  }
  return [value];
}
function ignextServerLoader() {
  const { pageQueries, functionQueries, middlewareQuery } = this.getOptions();
  const options = {
    pageQueries: toArray(pageQueries).map((q) => (0, import_querystring.parse)(q)),
    functionQueries: toArray(functionQueries).map((q) => (0, import_querystring.parse)(q)),
    middlewareQuery: middlewareQuery ? (0, import_querystring.parse)(middlewareQuery) : void 0
  };
  return `
	import {adapter} from "${import_path.default.resolve(__dirname, "../internal/adapter")}"

	const handlerOptions = ${buildHandlerOptions.call(this, options)};

	function createOnRequestHandler(manifestOptions) {
		return adapter({...handlerOptions, manifestOptions})
	}

	export {createOnRequestHandler};
	`;
}
function swapDistFolderWithEsmDistFolder(path2) {
  return path2.replace("next/dist/pages", "next/dist/esm/pages");
}
function buildHandlerOptions(loaderOptions) {
  if (loaderOptions.pageQueries.length === 0) {
    throw new Error("No page found");
  }
  const {
    dev,
    stringifiedConfig,
    absoluteDocumentPath,
    absoluteAppPath,
    absolute500Path,
    absoluteErrorPath
  } = loaderOptions.pageQueries[0];
  const stringifyPath = (path2) => {
    return path2 ? (0, import_stringify_request.stringifyRequest)(this, swapDistFolderWithEsmDistFolder(path2)) : void 0;
  };
  const stringifiedAppPath = stringifyPath(absoluteAppPath);
  const stringifiedErrorPath = stringifyPath(absoluteErrorPath);
  const stringifiedDocumentPath = stringifyPath(absoluteDocumentPath);
  const stringified500Path = stringifyPath(absolute500Path);
  const pageConfigs = {};
  function pageConfigSource(stringfiedPath, isAppPath) {
    return `{
			pageMod: require(${stringfiedPath}),
			isAppPath: ${JSON.stringify(isAppPath)}
		}`;
  }
  if (stringifiedErrorPath) {
    pageConfigs["/_error"] = pageConfigSource(stringifiedErrorPath, false);
  }
  if (stringified500Path) {
    pageConfigs["/500"] = pageConfigSource(stringified500Path, false);
  }
  for (const value of loaderOptions.pageQueries) {
    const appDirLoaderString = import_buffer.Buffer.from(
      value.appDirLoader ?? "",
      "base64"
    ).toString();
    const stringifiedPagePath = stringifyPath(value.absolutePagePath);
    const pageModPath = `${appDirLoaderString}${stringifiedPagePath.slice(
      1,
      -1
    )}`;
    pageConfigs[value.page] = pageConfigSource(
      JSON.stringify(pageModPath),
      value.pagesType === "app"
    );
  }
  const functionConfigs = {};
  for (const value of loaderOptions.functionQueries) {
    functionConfigs[value.page] = `(() => {
			const mod = require(${stringifyPath(value.absolutePagePath)});
			return mod.middleware || mod.default;
		})()`;
  }
  return `
		{
			dev: ${dev},
			config: ${stringifiedConfig},
			Document: ${stringifiedDocumentPath ? `require(${stringifiedDocumentPath}).default` : "undefined"},
			appMod: ${stringifiedAppPath ? `require(${stringifiedAppPath})` : "undefined"},
			pagesOptions: {${Object.entries(pageConfigs).map(([k, v]) => `"${k}": ${v}`).join(",")}},
			functionOptions: {${Object.entries(functionConfigs).map(([k, v]) => `"${k}": ${v}`).join(",")}},	
		}
	`;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
